# Notes

We're nearly ready to release version 1.0 of MahApps.Metro, so this may be the last unstable release.

There are no known breaking changes in this release, but we had to deprecate some things, particularly around the titlebar overlay behavior.

Please note that everything that is know deprecated will be removed in the 1.0 release, so you should prepare your applications soon.

Since we're following semantic versioning, we promise to not break anything from version 1.0 to 2.0.

# Features

## MetroWindow now indicates whether it's active or not

The `MetroWindow` now has the `NonActiveWindowTitleBrush` property that sets the window brush for an inactive window.

See PR #1320

## Fine grained control over the titlebar element overlay behavior

The overlay behavior of the elements of the window titlebar can now be controlled individually.

There are is now an enum with four values:
- `Never`
- `OverlayFlyout`
- `OverlayHiddenTitleBar`
- `Always`

For more info, see PR #1427.

## Underlined TabControl

Added the attached property `ControlsHelper.IsUnderlined="True"` for the `TabControl` control that adds an underline.

See PR #1425 for reference.

## Custom ScrollBar width and height

The default ScrollBar width and height can now be set manually.

See PR #1387for more infos.

## Direct FlatButton style

Previously you had to include the `FlatButton` resource dictionary to add a `FlatButton`.
Now you can just set it at style of a button.

## MetroWindow icon EdgeMode

It is now possible to set the `EdgeMode` of the window icon.

# Changes
- The `DropDownButton` now works less like a `SplitButton` #1442 #1459
- Made a disabled Textbox, RichTextbox and PasswordBox a bit more visible #1410 #1420

# Fixes

- Don't focus window titlebar elements #1472 #1475
- Fixed selection with SelectionUnit=CellOrRowHeader #1452
- Fixed treeview style to allow custom styling #1444 #1450
- Fixed the `Flyout`control opening again when clicking on a control under the overlay #1411 #1428
- Better coloring for blackout days #1133 #1426
- Fixed the MetroWindow GlowBrush remaining visible when hiding window #1422 #1403 #1424
- Enable text wrapping in ToggleSwitch Header #1415
- `TextboxHelper.Watermark` should respect padding #1247
- Fixed a blurry border on the `MetroButton` and `MetroToggleButton` style
- Fix the `ComboBox` `CanContentScroll usage
- Fixed the `ComboBox`virtualization #1132 #1394
- Fixed DataGrid cell padding not being applied #977 #1393
- Fixed various DataGrid issues #1381
- Fixed a Flyout problem with width bound to ancestors ActualWidth

There are some more fixes, for a detailed list look into the commit log.
