# Notes

MahApps.Metro v1.3.0 bug fix and feature release.

# Features / Changes (and Fixes)

- New `DateTimePicker` and `TimePicker` controls #2299 #2510 (@xxMUROxx)
- New Hotkey control `HotKeyBox` #2322 (@thoemmi)
- New 'Remember' CheckBox in `LoginDialog` #2308 #2305 (@manekovskiy)
- New `IconPacks` for MahApps: `PackIconMaterial`, `PackIconModern`, `PackIconFontAwesome` and `PackIconEntypo` #2328
    + Usage:  
        ```
        <Controls:PackIconMaterial Kind="EmoticonCool" Height="32" Width="32" />
        ```  
        or  
        ```
        <Controls:PackIconModern Kind="Cupcake" Height="24" Width="24" />
        ```
        or  
        ```
        <Controls:PackIconFontAwesome Kind="FontAwesome" Height="16" Width="16" />
        ```
        or  
        ```
        <Controls:PackIconEntypo Kind="ThumbsUp" />
        ```
    + Icon names can be found in `PackIconMaterialKind`, `PackIconModernKind`, `PackIconFontAwesomeKind` or `PackIconEntypoKind`
    + All icons can be found in the main sample (IconPacks)
- New `Auto Close` feature for `Flyout` #2228 #1710 (@Sikta)
    + Enable this by set `IsAutoCloseEnabled` to true
    + Time changable by `AutoCloseInterval` (default 5000 ms)
- Fix `PasswordBoxBindingBehavior` and `IsWaitingForData` #2355
    + Fixed: Behaviors in `StylizedBehaviors` should be detached on unload
    + Fixed: `PasswordBoxBindingBehavior`, it doesn't work e.g. in TabControl TabItems
    + `IsWaitingForData` for `MetroButtonTextBox`, `MetroPasswordBox`, `MetroButtonPasswordBox`, `MetroButtonRevealedPasswordBox`
    + PackIconMaterial `Eye` and ClearTextButton feature for `MetroButtonRevealedPasswordBox`
- Added `ContentStringFormat` TemplateBinding to ToolTip #2359 (@nrpog) #2363
- `ControlsHelper.ButtonWidth` for `ComboBox` and other stuff #2365
	+ set `ChromelessButtonStyle` Padding to 0
	+ new DependencyProperty `ButtonContentTemplate` in `TextBoxHelper`
	+ fix width of ClearText button if height change, e.g. by floating watermark
	+ fix background state colors (`IsPressed`, `IsMouseOver`)
	+ new sytle `MetroComboBoxDropDownToggleButtonStyle` for `ComboBox` toggle button
- Added `EllipseDiameterScale` to `ProgressRing` #2204 #2382 (@petvetbr)
- `WindowButtonCommands` enhancements #2378
	+ use ContentPresenter to show the WindowButtonCommands, so it's now possible easier to change the min/max/close button styles
	+ enable changing min/max/restore/close button tooltip
	+ new Win10 style/template: `MahApps.Metro.Styles.WindowButtonCommands.Win10` and `MahApps.Metro.Templates.WindowButtonCommands.Win10`  
	![2016-05-17_15h27_28](https://cloud.githubusercontent.com/assets/658431/15323811/0393ac9c-1c44-11e6-86ce-0a7416bd2621.png)  
	![2016-05-17_15h27_40](https://cloud.githubusercontent.com/assets/658431/15323816/074fd6c6-1c44-11e6-8894-39a0d61b9a08.png)
- Minor Automation API support for `Flyouts` and `NumericUpDown` #2381 #2166 (@petvetbr)
- Dialog font sizes setting implementation #2380 #2383 (@petvetbr, @punker76)
	+ changable via `DialogTitleFontSize` and `DialogMessageFontSize`
- New attached dependency property `TextButton` in TextBoxHelper which handles the visibility of the button in `MetroButtonPasswordBox` and `MetroButtonTextBox`styles #2387
- Win10 ToggleSwitch #2410
  + new Win10 toggle switch styles: `MahApps.Metro.Styles.ToggleSwitchButton.Win10` and `MahApps.Metro.Styles.ToggleSwitch.Win10`
  + new Metro toggle switch styles `MahApps.Metro.Styles.ToggleSwitchButton` and `MahApps.Metro.Styles.ToggleSwitch`
  + fixed broken `IsPressed` state
  + new brushes for the Win10 style  
  `MahApps.Metro.Brushes.ToggleSwitchButton.PressedBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.OffBorderBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.OffMouseOverBorderBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.OffDisabledBorderBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.OffSwitchBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.OnSwitchBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.OnSwitchDisabledBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.OnSwitchMouseOverBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.ThumbIndicatorBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.ThumbIndicatorMouseOverBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.ThumbIndicatorCheckedBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.ThumbIndicatorPressedBrush.Win10`  
  `MahApps.Metro.Brushes.ToggleSwitchButton.ThumbIndicatorDisabledBrush.Win10`
  + new keys for all accent colors: `AccentBaseColor` and `AccentBaseColorBrush` (full color)
- `Flyout` changes
	+ SetFlyoutOpenAction is now obsolete
	+ new/update template names BackButton, BackHeaderText
	+ new `CloseCommandParameter` dependency property
- `FlipView` changes
  + `MouseOverGlowEnabled` is now obsolete, use `MouseHoverBorderEnabled` instead
  + new `MouseHoverBorderBrush` and `MouseHoverBorderThickness` dependency property
- New dependency property `CircularNavigation` for the `FlipView` #2389
- `BindsTwoWayByDefault` removed from `IsActiveProperty` of `ProgressRing` #2438 (@xxMUROxx)
- Fix Flyout theme usage in `Caliburn.Micro` sample
- New dependency properties for `Tile` control: `HorizontalTitleAlignment` and `VerticalTitleAlignment` #2293
- New attached dependency properties `TextBoxHelper.ButtonFontSize` #2345 Also add a new font size `ClearTextButtonFontSize` (default to 16) for all 'ClearText' buttons
- Added a `MetroFlatToggleButton` style like MetroFlatButton #2481 (@Koopakiller)
- New `MetroThumbContentControl` for `MetroWindow` title #2487
	+ It's now possible again to have title templates with clickable controls
	+ Replaced `TitleCaps` with `TitleCharacterCasing` (marked as obsolete). Now title can be `Upper`, `Lower` or `Normal`
	+ Add new styles `MahApps.Metro.Styles.ContentControlEx` and `MahApps.Metro.Styles.MetroThumbContentControl`
- `Flyout` improvement caused by #2485 #2523
	+ use `ContentControlEx` for header, so it's now possible to use `ControlsHelper` attached properties `ContentCharacterCasing`, `HeaderFontSize`, `HeaderFontWeight` and `HeaderFontStretch`
	+ new attached property `ControlsHelper.HeaderMargin` to handle the Margin from Flyout side
- New dependency property `ShowDialogsOverTitleBar` for `MetroWindow? which allows showing title bar while showing dialogs (fixes #2109) #2534 (@Deadpikle)
- Store/Restore focused element methods which will be used automatically with dialogs (but can be also used explicit) #2532

# Closed Issues

- #2003 "VisualButton" That makes working with the XAML icons easier
- #2114 Icon color not changing on theme change (as #1029)
- #2275 Embed Material Design Icons (in addition to Modern UI Icons)?
- #1710 New "Auto Close" feature for Flyouts
- #2354 TextBoxHelper.ButtonClicked should pass ButtonCommandParameter to ButtonCommand.CanExecute
- #2343 Win8MetroPasswordBox Preview does not work with Tabcontrol (item > 1)
- #2352 Can't set ComboBox buttons width with ControlsHelper.ButtonWidth
- #2370 Pasting over selection in NumericUpDown doesn't work #2371 (@michaelprewecki)
- #1901 ThemeChanging causing app crash
- #1439 ComboBox in Toolbar closes if Scrollbar track/button is clicked
- #1972 Changing Close button icon
- #2166 Controls Do not get distinct automation ID's
- #2204 Progress ring dot scaling seems to be wrong (1.1.2)?
- #2380 Missing FontSize Property for ProgressDialog/ShowProgressAsync
- #2385 ButtonCommandMetroTextBox text displaid over icon.
- #2220 Why in the MetroButtonTextBox the visibility of PART_ClearText is not managed as the MetroTextBox?
- #2311 ComboBox won't toggle closed in ribbon
- #2396 ShowMetroDialogAsync does not raise DialogManager.DialogOpened event.
- #2402 Window Command ItemSource Binding
- #2403 NumericUpDown HasDecimals Is Broken. #2404 (@feinstein)
- #2415 ToggleSwitch "Click" event not triggered #2421
- #2413 Focusable (Selectable) Text in MessageDialog
- #2409 MetroWindow can be closed while a modal dialog is shown
- #2348 Thumb height of slider control
- #2340 How to change Datagrid Header Background using our custom style and based on MetroColumnHeader?
- #2390 PasswordBox CapsLockIndicator is not refreshed when host window is inactive
- #2416 WPF inside WF, Cannot close Flyouts and FlyView doesn't select
- #2432 Modal Flyouts Window Not Dragable
- #2333 FlipView SelectedIndex resetting bug
- #2214 Is there a way to control the "PART_GlowBorder" thickness in FlipView?
- #2126 FlipView.HideControlButtons() does not disable arrow keys.
- #2395 MahApps.Metro resource icons cannot be used repeatedly
- #2389 Circular FlipView
- #2056 ToggleButton foreground color when selected
- #1823 Cannot fully programatically maximize window.
- #2414 Focus is lost after a dialog is closed
- #2332 Calendar ignores IsTodayHighlighted property
- #2420 ShowmessageAsync Cancellation Exception #2454 (@MatthewKinsman)
- #2293 Align Tile Title
- #2459 MetroDialogSettings not being propagated to ProgressDialog by DialogManager
- #2462 Should a click on a MetroTabItems close button really clear the buttons Command and CommandParameter properties?
- #2345 Can't edit TextBoxHelper.ClearTextButton properties
- #2474 right to left DatePicker
- #2476 MetroWindow OnClosing exception (.Net 4.0)
- #2339 The Glow border does not follow the window is is used the UseNoneWindowStyle property!
- #2477 Create a custom Thumb for the title DragMove
- #2449 Visual bug while using RightWindowCommands
- #2495 Default for ControlsHelper.HeaderFontSizeProperty should be SystemFonts.MessageFontSize
- #2479 DefaultButtonFocus Not Working As Expected PR #2505
- #2514 NumericUpDown UseFloatingWatermark Issue
- #2485 Hiding close button and title leaves blank space in top-positioned flyouts #2485
- #2531 Setting TitleFontSize & CountFontSize in Tile is no longer working
- #2109 Size of MahApps Dialog background..
- #2538 Focus Message Dialog from flyout
- #2537 Bad contrast in ProgressDialog's progress bar
- #2532 ProgressDialog close causes loss of focus on child control
- #2486 DateTimePicker right click menu appearance
- #2524 DatePicker and DateTimePicker UseFloatingWatermark don't work
- #2269 Make Controls:TextBoxHelper.UseFloatingWatermark="True" work for DatePicker
- #2525 System.Windows.Media.Animation.DoubleAnimation' cannot use default origin value of 'Infinity
- #2552 How to hide flyout title
